# gbp-pq

## Name

gbp-pq -- Manage quilt patches on patch queue branches in git

## Synopsis

gbp pq [`--verbose`] [`--color=``[auto|on|off]`] [`--[no-]patch-numbers`] [`--topic=``topic`] [`--time-machine=``num`] `drop` | `export` | `import` | `rebase` | `switch`

## DESCRIPTION

gbp pq helps one to manage quilt patches in Debian packages that are maintained with gbp. This is especially useful with packages using the 3.0 (quilt) source format. With gbp pq you can maintain the quilt patches that should be applied to a package on a separate branch called patch-queue branch. So if your Debian package lives on `master` the associated patch-queue branch will be called `patch-queue/master`.

See https://honk.sigxcpu.org/piki/development/debian_packages_in_git/ for example workflows.

## ACTIONS

`import` | Create a patch queue branch from quilt patches in debian/patches/ that are listed in debian/patches/series.
`export` | Export the patches on the patch-queue branch associated to the current branch into a quilt patch series in debian/patches/ and update the series file.
`rebase` | Switch to the patch-queue branch associated to the current branch and rebase it against the current branch.
`drop` | Drop (delete) the patch queue associated to the current branch. So if you're on branch `foo` this would drop branch `patch-queue/foo`.
`apply` | Add a single patch to the patch-queue similar to using git-am. Use `--topic` if you want the patch to appear in a separate subdir when exporting the patch queue using `export`. This can be used to separate upstream pathes from debian specific patches.
`switch` | Switch to the patch-queue branch if on the base branch and switch to base branch if on patch-queue branch.

## OPTIONS

`--verbose`, `-v` | verbose execution
`--color=``[auto|on|off]` | Whether to use colored output.
`--[no-]patch-numbers` | Whether the patch files should start with a number or not.
`--topic=``topic` | Topic to use when importing a single patch
`--time-machine=``NUM` | When importing a patch queue fails, go back commit by commit on the current branch to check if the patch-queue applies there. Do this at most `NUM` times. This can be useful if the patch-queue doesn't apply to the current branch HEAD anymore, e.g. after importing a new upstream version.

## TAGS

When exporting patches from a patch-queue branch gbp pq will look at the patch header for special tags it recognizes. All tags need to start at the first column and require at least one whitespace after the colon.

`Gbp[-Pq]: Ignore` | Ignores the commit, no patch is generated out of it.

`Gbp[-Pq]: Topic` `topic`

Moves the patch into a subdir called `topic` when running

    gbp pq export

This allows for some structure below `debian/patches`.

`Gbp-Pq-Topic:` `topic` | Deprecated: use `Gbp[-Pq]: Topic` `topic` instead.

## SEE ALSO

gbp-buildpackage(1), dpkg-source(1), quilt(1), gbp.conf(5)

## AUTHOR

Guido Guenther `<agx@sigxcpu.org>`